<template>
  <v-container class="product mt-4" fluid>
    <v-row>
      <v-col cols="2">
        <categories-tree
          :categories="categories.tree"
          :category-slug="categorySlug"
          :selected-tree="selectedTree"
        ></categories-tree>
      </v-col>

      <v-col cols="10">
        <template v-if="$fetchState.pending">
          <div class="text-center mt-10">
            <v-progress-circular :size="96" color="light-blue" indeterminate></v-progress-circular>
          </div>
        </template>
        <template v-else-if="$fetchState.error">
          <!-- <h1>ERROR</h1> -->
        </template>
        <template v-else>
          <v-row>
            <v-col cols="6">
              <v-row>
                <v-col v-if="productsByColorVisible" cols="2" class="text-center">
                  <nuxt-link
                    v-for="prod in productsByColor.slice(0, productsByColorLimit)"
                    :key="`products-product-${prod.product_oasis_id}`"
                    :to="`${baseUrl}/${prod.category}/${prod.product_oasis_id}`"
                    class="d-flex mb-3"
                  >
                    <v-img :src="prod.images[0].small" width="100%" contain></v-img>
                  </nuxt-link>

                  <v-menu v-if="productsByColor.length > productsByColorLimit" top transition="slide-x-transition">
                    <template v-slot:activator="{ on, attrs }">
                      <v-btn v-bind="attrs" color="success" small v-on="on" v-text="productsByColorMoreButton"></v-btn>
                    </template>

                    <v-card flat class="pa-5" :width="productsByColorMenuWidth">
                      <nuxt-link
                        v-for="prod in productsByColor.slice(productsByColorLimit)"
                        :key="`products-product-${prod.product_oasis_id}`"
                        :to="`${baseUrl}/${prod.category}/${prod.product_oasis_id}`"
                        class="d-inline-block mr-4 mb-3"
                      >
                        <v-img :src="prod.images[0].small" width="100" contain></v-img>
                      </nuxt-link>
                    </v-card>
                  </v-menu>
                </v-col>

                <v-col :cols="productsByColorVisible ? 10 : 12">
                  <v-card flat>
                    <v-carousel cycle height="400" hide-delimiter-background show-arrows-on-hover>
                      <v-carousel-item
                        v-for="(item, i) in productImages"
                        :key="`product-image-${i}`"
                        :src="item.src"
                        reverse-transition="slide-x-transition"
                        transition="slide-x-transition"
                        @click="showOverlayImg(item.src)"
                      ></v-carousel-item>
                    </v-carousel>
                  </v-card>
                </v-col>
              </v-row>
              <v-row>
                <v-col cols="12">
                  <v-simple-table>
                    <template v-slot:default>
                      <tbody>
                        <tr v-for="(item, i) in productAttributes" :key="`product-attribute-${i}`">
                          <td>
                            <span class="font-weight-medium">{{ item.name }}:</span>
                          </td>
                          <td>{{ item.value }} {{ item.dim }}</td>
                        </tr>
                      </tbody>
                    </template>
                  </v-simple-table>
                </v-col>
              </v-row>
            </v-col>

            <v-col cols="6" class="pl-3">
              <div
                :class="{
                  'product__content-right': true,
                  'product__content-right--is-scrolled': contentOffsetTop > 0,
                }"
              >
                <v-breadcrumbs :items="breadcrumbs" class="pa-0"></v-breadcrumbs>

                <h1 class="mt-5 display-2 font-weight-light" v-text="productName"></h1>

                <div class="d-flex justify-space-between mt-3">
                  <div>
                    <span class="product__price display-2">{{ productPrice | formattedCost }}</span>
                    <span class="subtitle-1">₽</span>
                  </div>

                  <div class="mt-3 body-1">
                    <span class="font-weight-thin">{{ $t('text.product-article') }}: </span>
                    <v-chip color="pink lighten-5">{{ productArticle }}</v-chip>
                  </div>
                </div>

                <div>
                  <v-btn
                    v-for="category in productCategoriesLinks"
                    :key="`product-category-${category.id}`"
                    :to="`${baseUrl}/${category.id}`"
                    nuxt
                    x-small
                    class="mr-2 mb-2"
                    >{{ category.name }}</v-btn
                  >
                </div>

                <div>
                  <v-alert
                    v-if="Object.keys(productsBySizes).length"
                    color="light-blue"
                    border="top"
                    elevation="2"
                    colored-border
                    class="mt-5"
                  >
                    <v-simple-table>
                      <template v-slot:default>
                        <thead>
                          <tr>
                            <th class="text-center" v-text="$t('text.size')"></th>
                            <th class="text-center" v-text="$t('text.qty')"></th>
                            <th class="text-center" v-text="$t('text.stock')"></th>
                          </tr>
                        </thead>
                        <tbody>
                          <tr v-for="(item, k) in productsBySizes" :key="`product-sizes-${k}`">
                            <td class="text-center font-weight-bold" v-text="k"></td>
                            <td class="text-center px-8">
                              <v-text-field
                                v-model="quantity[k]"
                                solo
                                hide-details
                                class="my-2 mx-auto"
                                style="width: 150px"
                                :label="$t('text.qty')"
                              ></v-text-field>
                            </td>
                            <td class="text-center">{{ item.stock }}</td>
                          </tr>
                        </tbody>
                      </template>
                    </v-simple-table>
                  </v-alert>

                  <v-alert
                    v-if="cartTotal.qty"
                    color="light-green"
                    border="top"
                    elevation="2"
                    colored-border
                    class="mt-3"
                  >
                    <span>{{ $t('text.product-to-cart-qty') }}</span>
                    <v-chip>{{ cartTotal.qty }}</v-chip>
                    <span>{{ $tc('text.product-total', cartTotal.qty) }}</span>
                    <span>{{ $t('text.product-to-cart-sum') }}</span>
                    <v-chip>{{ cartTotal.sum | formattedCost }} ₽</v-chip>
                  </v-alert>

                  <v-row v-if="productStock" class="mt-4">
                    <v-col v-if="productQtyInvalid" cols="12">
                      <v-alert border="top" colored-border type="error" elevation="2" class="mb-0">
                        {{ $t('text.product-qty-invalid') }}
                      </v-alert>
                    </v-col>

                    <v-col cols="12">
                      <div class="d-flex align-center">
                        <div class="product__add2cart">
                          <v-btn
                            large
                            color="pink darken-2"
                            dark
                            depressed
                            class="transition-fast-in-fast-out px-10 py-7"
                            @click="addToCart"
                          >
                            <v-icon left>mdi-cart-plus</v-icon> {{ $t('button.add-to-cart') }}
                          </v-btn>
                        </div>

                        <v-hover v-slot:default="{ hover }">
                          <v-btn text small :class="{ 'ml-5': true, 'light-blue--text': !hover, 'red--text': hover }">
                            <v-icon left :large="hover" v-text="hover ? 'mdi-heart' : 'mdi-heart-outline'"></v-icon>
                            <span
                              :class="{ 'transition-fast-in-fast-out': true, 'pl-3': hover }"
                              v-text="$t('button.add-to-wishlist')"
                            ></span>
                          </v-btn>
                        </v-hover>

                        <v-spacer></v-spacer>

                        <v-chip color="transparent">
                          <v-avatar left color="light-green" class="white--text">
                            <v-icon>mdi-check</v-icon>
                          </v-avatar>
                          {{ $t('text.product-available') }}
                        </v-chip>
                      </div>
                    </v-col>
                  </v-row>
                  <v-alert v-else border="top" colored-border type="error" class="mt-4" elevation="2">
                    {{ $t('text.product-not-available') }}
                  </v-alert>
                </div>

                <p class="mt-3">{{ productDescription }}</p>
              </div>
            </v-col>
          </v-row>
        </template>
      </v-col>
    </v-row>

    <v-overlay :value="imgOverlay.value">
      <v-card max-width="80%" class="ma-auto">
        <v-btn color="gray" fab dark large absolute top right @click="imgOverlay.value = false">
          <v-icon>mdi-close</v-icon>
        </v-btn>

        <v-card-text v-if="imgOverlay.src">
          <v-img :src="imgOverlay.src" contain width="100%"></v-img>
        </v-card-text>
      </v-card>
    </v-overlay>
  </v-container>
</template>

<script>
const ATTR_NAMES = {
  size: 'Размер',
  color: 'Цвет товара',
}

export default {
  async fetch() {
    try {
      const data = await this.$api('v1').request(`oasis/product?id=${this.productSlug}`)

      this.products = data.products
      this.product = data.products.find(p => p.product_oasis_id === data.product.id)
      this.title = this.product.full_name
    } catch (err) {
      this.$fetchState.error = true
      this.$nuxt.error({ statusCode: 404 })
    }

    this.colors = JSON.parse(process.env.OASIS_PRODUCT_COLORS || '{}')
  },

  data: () => ({
    title: '',
    products: {},
    product: {},
    colors: {},
    quantity: {},
    cart: {},
    imgOverlay: {
      value: false,
      src: null,
    },
    cartChangeNotify: false,
    cartAddingAttempt: 0,
    minQty: 1,
    productsByColorLimit: 4,
    productsByColorMaxWidth: 625,
    attributesCols: 2,
    contentOffsetTop: 0,
  }),

  computed: {
    baseUrl() {
      return process.env.CATALOG_BASE_URL
    },

    categories() {
      return this.$store.state.catalog.categories
    },

    categorySlug() {
      return this.$route.params.category
    },

    productSlug() {
      return this.$route.params.product
    },

    productOasisId() {
      return this.product.product_oasis_id || ''
    },

    productName() {
      return this.product.full_name || ''
    },

    productDescription() {
      return this.product.description || ''
    },

    productArticle() {
      return this.product.article || ''
    },

    productAttributes() {
      return (this.product.attributes || []).filter(attr => attr.value)
    },

    productMaterials() {
      return this.product.materials || []
    },

    productColors() {
      return this.product.colors || []
    },

    productPrice() {
      return this.product.price || 0
    },

    productCategories() {
      return this.product.full_categories || []
    },

    productCategoriesLinks() {
      return this.categories.flat.filter(category => category.parent_id && this.productCategories.includes(category.id))
    },

    productImages() {
      return (this.product.images || []).map(image => ({ src: image.superbig }))
    },

    productRating() {
      return this.product.rating || 0
    },

    productStock() {
      return parseInt(this.product.stock_msk) || 0
    },

    productsAttrs() {
      if (!this.products.length) return []

      const results = {
        size: {},
        color: {},
      }

      this.products.forEach(p => {
        for (const k in results) {
          const attrs = p.attributes.filter(a => a.name === ATTR_NAMES[k])

          if (attrs.length) {
            attrs.forEach(attr => {
              const { value } = attr

              results[k][value] = [...(results[k][value] || []), ...[p.product_oasis_id]]
            })
          }
        }
      })

      return results
    },

    productsByColor() {
      if (!this.products.length) return []
      return Object.values(this.productsAttrs.color).map(list =>
        this.products.find(p => list[0] === p.product_oasis_id)
      )
    },

    productsByColorVisible() {
      return this.productsByColor.length > 1
    },

    productsByColorHiddenLen() {
      return this.productsByColor.length - this.productsByColorLimit
    },

    productsByColorMoreButton() {
      const text = this.$t('button.get-additive')
      const len = this.productsByColorHiddenLen
      return `${text} ${len}`
    },

    productsByColorMenuWidth() {
      return this.productsByColorHiddenLen > this.productsByColorLimit ? this.productsByColorMaxWidth : 'auto'
    },

    productsBySizes() {
      if (!this.products.length) return null

      const results = {}
      const color = this.product.attributes.find(a => a.name === ATTR_NAMES.color)

      if (color) {
        const idList = this.productsAttrs.color[color.value]

        for (const k in this.productsAttrs.size) {
          const products = this.productsAttrs.size[k]
            .filter(id => idList.includes(id))
            .map(id => this.products.find(p => p.product_oasis_id === id))

          if (products.length) {
            const stock = products.reduce((acc, cur) => acc + parseInt(cur.stock_msk), 0)

            results[k] = { products, stock }
          }
        }

        return results
      }

      return null
    },

    productQtyInvalid() {
      return this.cartAddingAttempt > 0 && !Object.keys(this.cart).length
    },

    cartTotal() {
      if (!Object.keys(this.cart).length) return {}

      return {
        qty: Object.values(this.cart).reduce((acc, cur) => acc + cur, 0),
        sum: Object.keys(this.cart).reduce((acc, cur) => {
          const product = this.products.find(p => p.product_oasis_id === cur)
          return acc + parseFloat(product.price, 0) * parseInt(this.cart[cur])
        }, 0),
      }
    },

    selectedTree() {
      const result = []
      const getCategory = id => this.categories.flat.find(category => category.id === parseInt(id)) || {}
      let category = getCategory(this.categorySlug)

      while (parseInt(category.parent_id || 0) !== 0) {
        result.push(category.id)
        category = getCategory(category.parent_id)
      }

      return result
    },

    breadcrumbs() {
      return this.categories.flat
        .filter(category => this.selectedTree.includes(category.id))
        .map(category => ({
          text: category.name,
          href: `${this.baseUrl}/${category.id}`,
          disabled: false,
        }))
    },
  },

  watch: {
    quantity: {
      handler(val) {
        const cart = {}

        for (const k in val) {
          const id = this.productsBySizes[k].products[0].product_oasis_id
          const qty = parseInt(val[k].toString().replace(/\D/g, ''), 0)

          if (qty) {
            cart[id] = qty
          }
        }

        this.cart = cart
      },
      deep: true,
    },
  },

  mounted() {
    /* try {
      window.addEventListener('scroll', e => {
        const scrollTop = window.pageYOffset || document.documentElement.scrollTop
        const contentEl = document.querySelector('.product__content-right') || {}
        // const headerEl = document.querySelector('.app-header') || {}
        // const headerHeight = headerEl.clientHeight || 0

        if (contentEl) {
          this.contentOffsetTop = scrollTop - contentEl.offsetTop
        }
      })
    } catch (error) {
      console.warn(`[pages/catalog/_category/_product]: ${error}`)
    } */
  },

  methods: {
    showOverlayImg(src) {
      const value = true
      this.imgOverlay = { value, src }
    },

    addToCart() {
      this.cartAddingAttempt++

      if (!Object.keys(this.cart).length) {
        if (!Object.keys(this.productsBySizes).length) {
          const cart = { [this.productOasisId]: this.minQty }
          this.cart = cart
        } else {
          return false
        }
      }

      for (const id in this.cart) {
        const qty = this.cart[id]
        this.$store.commit('catalog/ADD_TO_CART', { id, qty })
        this.quantity = {}
      }

      this.cart = {}
      this.cartAddingAttempt = 0

      if (this.cartChangeNotify) {
        this.$store.commit('SET_SNACKBAR', {
          color: 'light-green',
          text: this.$t('text.cart-item-added'),
        })
      }
    },
  },

  head() {
    const { APP_NAME } = process.env
    return {
      title: this.title,
      titleTemplate: `%s | ${APP_NAME}`,
      // meta: [{ hid: 'description', name: 'description', content: this.description }]
    }
  },
}
</script>

<style lang="scss" scoped>
.product {
  /* h1 {
    color: rgba(38, 50, 56, 0.8);
  } */

  &__content-right {
    /* &--is-scrolled {
      position: fixed;
      transform: translateY(-30%);
    } */
  }

  &__price {
    font-family: $numerals-font-family;
  }

  &__add2cart {
    position: relative;

    &::before {
      position: absolute;
      z-index: 0;
      bottom: 0;
      left: 0;
      width: 100%;
      height: 100%;
      background: linear-gradient(135deg, #d06383 0%, #c1e782 100%);
      border-radius: 40px;
      content: '';
      filter: blur(25px);
      transform: translateY(10px) scale(0.9);
      transition: all 0.3s ease-in-out;
    }

    button {
      background: linear-gradient(135deg, #f9c823 0%, #fc506e 100%);
      border-radius: 40px;
      font-weight: 600;
      letter-spacing: normal;
    }

    &:hover {
      button {
        animation: hue-rotation 10s linear 0ms infinite !important;
      }
    }
  }

  .v-overlay {
    .v-btn {
      transform: translate(50%, 0);
    }
  }
}
</style>
